<template>
    <div id="board - undefined" class="board" />
</template>

<script lang="ts">
import Goban from '@/components/goban/GobanJeu.vue';
import Component, { mixins } from 'vue-class-component';
import Coup from '@/classes/Coup';
import Possibilite from '@/classes/Possibilite';
// @ts-ignore
import WGo from 'wgo';
import { getInstanceEtatEdition } from './EtatEdition';
import EditionMarqueur from './EditionMarqueur';
import previsualiserCoupsSuivants from './PrevisualisationCoupsSuivants';
import rechercherPossibiliteAvecBaseIdentique from './RecherchePossibilitesAvecBaseIdentique';
@Component
export default class GobanEdition extends mixins(Goban) {
    private etatEdition: any;

    private editionMarqueur: EditionMarqueur = new EditionMarqueur(this);
    private nextMoves: Coup[] = [];
    private toolSwitched = false;

    created() {
        this.etatEdition = getInstanceEtatEdition();
        this.ajouterEventClavier(this);
        this.$root.$on('modifierPosition', afficherPrevisu => {
            this.afficherPossibiliteEnCours(afficherPrevisu);
        });
        this.$root.$on('changerTailleGoban', (tailleGoban, position) =>
            this.changerTaille(tailleGoban, position)
        );
    }

    mounted() {
        this.definirTailleGoban(
            this.etatEdition.tailleGoban,
            this.etatEdition.position
        );
        this.afficherDebut();
    }

    gererCapturePierre(pierresCapturees: any[]) {
        if (pierresCapturees) {
            pierresCapturees.forEach(element => {
                this.retirerElement(element.x, element.y);
            });
        }
    }

    ajouterEventClavier(goban: GobanEdition) {
        window.addEventListener('keydown', function(event) {
            if (event.defaultPrevented) {
                return;
            }
            switch (event.key) {
                case 'Shift':
                    if (!goban.toolSwitched) {
                        goban.switchTool();
                        goban.toolSwitched = true;
                    }
                    break;
            }
        });
        window.addEventListener('keyup', function(event) {
            if (event.defaultPrevented) {
                return;
            }

            switch (event.key) {
                case 'Shift':
                    goban.switchTool();
                    goban.toolSwitched = false;
            }
        });
    }

    definirSize() {
        this.size =
            document.getElementById('edition-container').clientWidth * 0.6;
    }

    getListener() {
        return (x, y) => {
            if (this.etatEdition.isOutilMarqueur()) {
                if (this.etatEdition.isConfiguration()) {
                    this.editionMarqueur.editerMarqueur(x, y);
                } else {
                    rechercherPossibiliteAvecBaseIdentique().forEach(
                        possibilite =>
                            this.editionMarqueur.editerMarqueurPossibilite(
                                x,
                                y,
                                possibilite
                            )
                    );
                }
            }
            if (this.etatEdition.isOutilPierre()) {
                if (this.etatEdition.isConfiguration()) {
                    if (this.isPierreValide(x, y, this.etatEdition.getTool())) {
                        this.putPierre(x, y, this.etatEdition.getTool());
                        this.stockerPierres(x, y);
                    } else {
                        this.retirerElement(x, y);
                        this.game.removeStone(x, y, this.etatEdition.getTool());
                        this.destockerPierres(x, y);
                    }
                } else {
                    this.$root.$emit('enregistrerCommentaire');
                    const indexPossibleAvecCoup = this.getPossibiliteAvecCoup(
                        x,
                        y
                    );
                    if (indexPossibleAvecCoup == -1) {
                        const possibiliteActuelle = this.getPossibiliteEnCours();
                        if (
                            possibiliteActuelle.isIndexADernierePierre(
                                this.etatEdition.getIndexPierre()
                            )
                        ) {
                            if (
                                this.isPierreValide(
                                    x,
                                    y,
                                    this.etatEdition.getTool()
                                )
                            ) {
                                this.retirerPrevisualisation();
                                this.jouerPierreDansPossibilite(x, y);
                            }
                        } else {
                            if (
                                this.isPierreValide(
                                    x,
                                    y,
                                    this.etatEdition.getTool()
                                )
                            ) {
                                this.retirerPrevisualisation();
                                this.creerNouvelleVariation(
                                    possibiliteActuelle
                                );
                                this.etatEdition.varierPossibiliteEnCours(true);
                                this.jouerPierreDansPossibilite(x, y);
                            }
                        }
                    } else {
                        this.rejouerPierreExistante(
                            x,
                            y,
                            indexPossibleAvecCoup
                        );
                    }
                    this.$root.$emit('initPosition');
                }
            }
        };
    }

    public getPossibiliteEnCours(): Possibilite {
        return this.etatEdition.possibiliteEnCours;
    }

    public getCoupEnCours(): Coup {
        return this.etatEdition.coupEnCours;
    }

    private rejouerPierreExistante(
        x: number,
        y: number,
        indexPossibleAvecCoup: number
    ) {
        this.etatEdition.setIndexPossibilite(indexPossibleAvecCoup);
        const coup: Coup = this.getPossibiliteEnCours().getCoups()[
            this.etatEdition.getIndexPierre() + 1
        ];
        this.rejouerCoupExistant(coup);
    }

    private rejouerCoupExistant(coup: Coup) {
        this.retirerPrevisualisation();
        this.ajouterCoup(coup);
        this.changerCouleur();
        this.etatEdition.varierCoupEnCours(true);
        this.nextMoves = previsualiserCoupsSuivants(this.board);
        this.placerMarqueursPossibilite(this.getPossibiliteEnCours());
    }

    private placerMarqueursPossibilite(possibilite: Possibilite) {
        possibilite
            .getMarqueurs()
            .filter(
                marqueur =>
                    marqueur.getPosition() == this.etatEdition.getIndexPierre()
            )
            .forEach(marqueur => this.afficherMarqueur(marqueur));
    }

    private creerNouvelleVariation(possibiliteActuelle: Possibilite) {
        const nouvellePossibilite = possibiliteActuelle.clonerAIndex(
            this.etatEdition.getIndexPierre()
        );
        this.etatEdition.possibilites.splice(
            this.etatEdition.getIndexPossibilite() + 1,
            0,
            nouvellePossibilite
        );
    }

    private jouerPierreDansPossibilite(x: number, y: number) {
        const tool = this.definirCouleurPierreSelonDernierCoup();
        if (this.isPierreValide(x, y, tool)) {
            this.ajouterPierre(x, y, tool);
            this.stockerPierresVariation(x, y, tool);
            this.changerCouleur();
            this.etatEdition.varierCoupEnCours(true);
        }
    }

    private getPossibiliteAvecCoup(x: number, y: number): number {
        const possibiliteAvecCoup = rechercherPossibiliteAvecBaseIdentique().filter(
            possibilite => {
                if (
                    this.etatEdition.getIndexPierre() <
                    possibilite.getCoups().length - 1
                ) {
                    const coupSuivantPossiblite = possibilite.getCoups()[
                        this.etatEdition.getIndexPierre() + 1
                    ];
                    return (
                        coupSuivantPossiblite.getX() == x &&
                        coupSuivantPossiblite.getY() == y
                    );
                }
                return false;
            }
        );
        return possibiliteAvecCoup.length > 0
            ? this.etatEdition.possibilites.indexOf(possibiliteAvecCoup[0])
            : -1;
    }

    private retirerPrevisualisation() {
        this.nextMoves.forEach(coup =>
            this.board.removeObjectsAt(coup.getX(), coup.getY())
        );
        this.nextMoves = [];
    }

    private stockerPierres(x: number, y: number) {
        const coup = new Coup();
        coup.setX(x);
        coup.setY(y);
        coup.setTool(this.etatEdition.getTool());
        if (this.etatEdition.getTool() === WGo.B) {
            this.etatEdition.pierresNoires.push(coup);
        } else if (this.etatEdition.getTool() === WGo.W) {
            this.etatEdition.pierresBlanches.push(coup);
        }
    }

    private stockerPierresVariation(x: number, y: number, tool: string) {
        const coup = new Coup();
        coup.setX(x);
        coup.setY(y);
        coup.setTool(tool);
        this.etatEdition.addCoup(coup);
    }

    private destockerPierres(x: number, y: number) {
        this.etatEdition.pierresNoires = this.etatEdition.pierresNoires.filter(
            coup => !coup.isMemePosition(x, y)
        );
        this.etatEdition.pierresBlanches = this.etatEdition.pierresBlanches.filter(
            coup => !coup.isMemePosition(x, y)
        );
    }

    private definirCouleurPierreSelonDernierCoup(): string {
        if (this.etatEdition.getIndexPierre() == -1) {
            return WGo.B;
        } else {
            const derniereCouleur = this.getCoupEnCours().getTool();
            return derniereCouleur === WGo.B ? WGo.W : WGo.B;
        }
    }

    public changerTaille(taille: string, position: Record<string, any>) {
        this.etatEdition.reinitialiser();
        this.definirTailleGoban(taille, position);
        this.setGame(Number.parseInt(taille));
    }

    private definirTailleGoban(taille: string, position: Record<string, any>) {
        this.board.setSection(this.definirSection(position));
        this.board.setSize(taille);
    }

    public switchTool() {
        if (this.etatEdition.isOutilPierre()) {
            this.etatEdition.changerCouleur();
        }
    }

    public afficherPossibiliteEnCours(afficherPrevisu: boolean) {
        const possibiliteSuivante: Possibilite = this.getPossibiliteEnCours();
        if (
            possibiliteSuivante.getCoups().length - 1 >=
            this.etatEdition.getIndexPierre()
        ) {
            this.afficherDebut();
            for (let i = 0; i <= this.etatEdition.getIndexPierre(); i++) {
                const coup = possibiliteSuivante.getCoups()[i];
                this.ajouterCoup(coup);
            }
            this.placerMarqueurs();
            if (afficherPrevisu) {
                this.nextMoves = previsualiserCoupsSuivants(this.board);
            }
        }
    }

    private afficherDebut() {
        this.setGame(Number.parseInt(this.etatEdition.tailleGoban));
        this.board.removeAllObjects();
        this.supprimerMarqueursEnCours();
        this.etatEdition.pierresNoires.forEach(coup => this.ajouterCoup(coup));
        this.etatEdition.pierresBlanches.forEach(coup =>
            this.ajouterCoup(coup)
        );
        this.placerMarqueurs();
    }

    private placerMarqueurs() {
        if (this.etatEdition.getIndexPierre() > -1) {
            this.placerMarqueursPossibilite(this.getPossibiliteEnCours());
        } else {
            this.etatEdition.marqueurs.forEach(marqueur =>
                this.afficherMarqueur(marqueur)
            );
        }
    }
}
</script>
